# -*- coding: utf-8 -*-
import libmediathek3 as libMediathek
import nexx
import json
import re

nexx.operations = {
'all':'d382c9357a607ea09c249e196428f39b',
'bestrated':'fcdab7b1139f86b33632299cbdc8c132',
'byid':'dd070e3baf94dc2de0940e08291c6075',
'byplaylist':'c4230d7f8d944b88fffd4b94825bcf15',
'byshowid':'37b5d1dfed297b569f4435579e3c16f8',
'bystudio':'6ce32eb63b71c3e5bbee23cbc81e78d2',
'latest':'758bb5f9adf6a9fdcdf2045128b039d1',
'mostactive':'58989e015b032b748b3eaff49b3c8d25',
}
nexx.streamtype2operation = {
'shows':'byshowid',
'studios':'bystudio',
'playlists':'byplaylist',
}

nexx.blacklist = ['2095']
nexx.channelId = '748'
nexx.base = 'https://api.nexx.cloud/v3/'
nexx.origin = 'http://www.spiegel.tv'

cid = '114971895300002774'


	
	
def main():
	l = []
	l.append({'_name':'Neu', '_type':'dir', 'path':'/videos/latest', 'streamtype':'videos', 'operation':'latest', 'mode':'listVideos'})
	l.append({'_name':'Meistgesehen', '_type':'dir', 'path':'/videos/mostactive', 'streamtype':'videos', 'operation':'mostactive', 'mode':'listVideos'})
	l.append({'_name':'Sendungen', '_type':'dir', 'streamtype':'shows', 'operation':'all', 'mode':'listDir'})
	l.append({'_name':'Themen', '_type':'dir', 'streamtype':'playlists', 'operation':'all', 'mode':'listDir'})
	l.append({'_name':'Studios', '_type':'dir', 'streamtype':'studios', 'operation':'all', 'mode':'listDir'})
	
	#Film der Woche
	#response = libMediathek.getUrl('http://www.spiegel.tv')
	#items = re.compile('_topbannerdata=\[\{(.+?)\}', re.DOTALL).findall(response)[0]
	#j = json.loads('{'+items+'}')
	#l.append({'_name':'Film der Woche: ' + j['title'], '_type':'video', 'url':'http://www.spiegel.tv/videos/'+j['navparam'], '_thumb':j['thumb'], 'mode':'playMovie'})
	
	return l
	
def listDir():
	nexx.streamtype = params['streamtype']
	l = nexx.listDir()
	libMediathek.sortAZ()
	return l

def listVideos():
	nexx.operation = params['operation']
	if 'path' in params:
		nexx.path = params['path']
	else:
		nexx.streamtype = params['streamtype']
		nexx.operation = params['operation']
		nexx.id = params['id']
	return nexx.listVideos()
	
def playMovie():
	response = libMediathek.getUrl(params['url'])
	oneconfig = re.compile('_oneconfig=(.+?);', re.DOTALL).findall(response)[0]
	j = json.loads(oneconfig)
	params['id'] = re.compile("<div id='videoplayer'>.+?data-itemid='(.+?)'").findall(response)[0]
	return play()
	
def play():	
	return nexx.getVideoUrl(params['id'])

modes = {
'main': main,
'listDir': listDir,
'listVideos': listVideos,
'playMovie': playMovie,
'play': play
}	


def list():	
	global params
	params = libMediathek.get_params()
	mode = params.get('mode','main')
	
	if mode == 'play':
		libMediathek.play(play())
	elif mode == 'playMovie':
		libMediathek.play(playMovie())
	else:
		l = modes.get(mode,main)()
		libMediathek.addEntries(l)
		libMediathek.endOfDirectory()	
list()

